var http 		= require('http');
var app 		= require('express')();
var httpServer = http.Server( app );
var bodyParser 	= require('body-parser');
var httpSocket = http.createServer();
var io 			= require('socket.io')( httpSocket, { path: '/socketio' } );


//const cron = require("node-cron");
//let shell = require("shelljs");





/*var mysql      	= require('mysql');
var db 			= mysql.createConnection({
  host     : process.env.DB_HOST,
  user     : process.env.DB_USERNAME,
  password : process.env.DB_PASSWORD,
  database : process.env.DB_DATABASE
});

db.connect();
*/

let shell = require("shelljs");
shell.cd('/var/www/colibriauction/nodeJS/');

var visitorItems = [];

var userItems = [];

var dotenv = require('dotenv');
dotenv.config({ path: '../.env' });

app.use( bodyParser.json() );       // to support JSON-encoded bodies
app.use( bodyParser.urlencoded({     // to support URL-encoded bodies
  extended: true
}));

var sockets = {};

io.set('transports', ['websocket', 'polling']);

io.on('connection', function (socket) {

    //console.log(socket);
    if(socket.handshake.query.userId !== undefined && socket.handshake.query.userId !== 0){
        console.log('A user has logged in: ' + socket.handshake.query.userId);
        var _room = 'user_' + socket.handshake.query.userId;

        userItems[_room] = socket.handshake.query.followedItems;

        socket.join( _room );
    }
    else if (socket.handshake.query.itemId !== undefined && socket.handshake.query.itemId !== 0){
        console.log('A user joined an item auction: ' + socket.handshake.query.itemId);
        var _room = 'item_' + socket.handshake.query.itemId;

        socket.join( _room );
    }
    else if(socket.handshake.query.visitorId !== undefined && socket.handshake.query.visitorId !== 0) {
        console.log('A visitor has opened the site: ' + socket.handshake.query.visitorId);
        var _room = 'visitor_' + socket.handshake.query.visitorId;

        visitorItems[_room] = socket.handshake.query.followedItems;

        socket.join( _room );
    }

    else if(socket.handshake.query.itemsId !== undefined && socket.handshake.query.itemsId !== 0) {
        console.log('A user opened butlers view: ' + socket.handshake.query.itemsId);

        var items_array = socket.handshake.query.itemsId.split(',');
        //console.log(items_array);
        for(var i = 0; i < items_array.length; i++)
        {
            var _room = 'item_' + items_array[i];
            console.log('A user joined an item butler: ' + items_array[i]);
            socket.join( _room );
        }

        /*var _room = 'visitor_' + socket.handshake.query.visitorId;

        visitorItems[_room] = socket.handshake.query.followedItems;*/
    }

    //socket.join( _room );

    console.log(visitorItems);
    console.log(userItems);

	socket.on('disconnect', function () {
	    if(this.handshake.query.visitorId !== undefined && this.handshake.query.visitorId !== 0){
	        var room_to_delete = 'visitor_' + this.handshake.query.visitorId;
	        delete visitorItems[room_to_delete];
        }

        if(this.handshake.query.userId !== undefined && this.handshake.query.userId !== 0){
            var room_to_delete = 'user_' + this.handshake.query.userId;
            delete userItems[room_to_delete];
        }

        console.log('A socket disconnected');
	});
});


/*
io.use((socket, next) => {
    if(socket.request.headers.cookie){
        db.query("SELECT * FROM users WHERE id = " + socket.handshake.query.uid, function (err, result) {

            if (result && result.length) {
                var user = result[0];
                socket.user = user;
                return next();
            } else next(new Error('Authentication error'));
        });
    }
    else{
        next(new Error('Authentication error'));
    }
    return next();
});
*/


app.post('/api/socketio/auction/newBid', function(req, res) {

    console.log('Emitting socket event -auction.newBid-... to: ' + 'item_' + req.body.item.id);
    var input = req.body,
		_room = 'item_' + input.item.id;


	io.to( _room ).emit('auction.newBid', input);

    console.log('Event -auction.newBid- emitted...');

    var affectedVisitors = [];

    for(var visitor_room in visitorItems) {
        if(visitorItems[visitor_room].split(',').includes(input.item.id)){

            affectedVisitors.push(visitor_room);
        }
    }

    if(affectedVisitors.length > 0)
    {
        for(var i = 0; i < affectedVisitors.length; i++){
            var _visitor = affectedVisitors[i];
            console.log('Emitting socket event -visitor.updateItems-... to: ' + _visitor);
            io.to( _visitor ).emit('visitor.updateItems', input);
            console.log('Event -visitor.updateItems- emitted...');
        }
    }


    var affectedUsers = [];

    for(var user_room in userItems) {
        if(userItems[user_room].split(',').includes(input.item.id)){

            affectedUsers.push(user_room);
        }
    }

    if(affectedUsers.length > 0)
    {
        for(var i = 0; i < affectedUsers.length; i++){
            var _user = affectedUsers[i];
            console.log('Emitting socket event -user.updateItems-... to: ' + _user);
            io.to( _user ).emit('user.updateItems', input);
            console.log('Event -user.updateItems- emitted...');
        }
    }

	return res.send('ok');
});

app.post('/api/socketio/auction/ended', function(req, res) {

    var input = req.body,
		_room = 'item_' + input.item.id;

	io.to( _room ).emit('auction.ended', input);

	return res.send('ok');
});

app.post('/api/socketio/user/newNotification', function(req, res) {

    console.log('Emitting socket event -user.newNotification-...');
    var input = req.body,
        _room = 'user_' + input.user;
    io.to( _room ).emit('user.newNotification', input);
    console.log('Event -user.newNotification- emitted...');

    return res.send('ok');
});

/*
function notifyAffectedVisitors(visitor_room, input)
{
    console.log('Emitting socket event -visitor.updateItems-...');
    io.to(visitor_room).emit('visitor.updateItems', input);
    console.log('Event -visitor.updateItems- emitted...');
}

app.post('/api/socketio/visitor/updateItems', function(req, res) {

    console.log('Emitting socket event -visitor.updateItems-...');

    io.to(visitor_room ).emit('visitor.updateItems', input);
    console.log('Event -visitor.updateItems- emitted...');

    return res.send('ok');
})
*/

//httpSocket.listen(9090, '172.31.43.146');

httpSocket.listen(process.env.SOCKET_PORT, process.env.SOCKET_URL);

httpServer.listen(process.env.NODE_PORT, process.env.NODE_URL, function() {
	//console.log('Listening...');
    console.log('Listening on ' + process.env.NODE_URL + ':' + process.env.NODE_PORT);



});